/* heapAlloc.c */

#include "heap_types.h"

void *heapAlloc( HeapUID uid, SceSize size )
{
	struct heap_allocated_memblock_header *cur  = (struct heap_allocated_memblock_header *)uid;
	struct heap_allocated_memblock_header *prev = NULL;
	struct heap_allocated_memblock_header *heap = NULL;
	SceSize alloc_size;
	
	/* mۂTCY0̏ꍇ́A1w肳ꂽ̂ƌȂ */
	if( ! size ) size = 1;
	
	alloc_size = size + sizeof( struct heap_allocated_memblock_header ) + HEAP_ALIGN_SIZE;
	
	/* 擪vf̓q[vŜ̏Ƃēʈ */
	if( ! cur->next ){
		if( cur->size < alloc_size ) return NULL;
		cur->next = (struct heap_allocated_memblock_header *)MEMORY_ALIGN_ADDR( HEAP_ALIGN_SIZE, ( (uintptr_t)cur + sizeof( struct heap_allocated_memblock_header ) ) );
		cur->next->size = alloc_size;
		cur->next->next = NULL;
		return (void *)( (uintptr_t)cur->next + sizeof( struct heap_allocated_memblock_header ) );
	} else{
		/* ł蓖ĂĂ΁Arootƍŏ̗vf̊Ԃɋ󂫗eʂȂ */
		struct heap_allocated_memblock_header *topheap = (struct heap_allocated_memblock_header *)( (uintptr_t)cur + sizeof( struct heap_allocated_memblock_header ) );
		
		if( (uintptr_t)(cur->next) - (uintptr_t)topheap >= alloc_size ){
			topheap->size = alloc_size;
			topheap->next = cur->next;
			cur->next = (struct heap_allocated_memblock_header *)MEMORY_ALIGN_ADDR( HEAP_ALIGN_SIZE, topheap );
			return (void *)( (uintptr_t)topheap + sizeof( struct heap_allocated_memblock_header ) );
		}
	}
	
	prev = cur->next;
	cur  = prev->next;
	
	/* \ȋ󂫗eʂTĎ擾 */
	for( ; cur; prev = cur, cur = cur->next ){
		/*
			ÕubN̏I[(prev + prev->size)ƌ݂̃ubN(cur)̍A
			gpTCYZoAKvȗeʂ󂢂ĂΎgpAłȂΎցB
		*/
		if( (uintptr_t)cur - ( (uintptr_t)prev + prev->size ) >= alloc_size ){
			heap = (struct heap_allocated_memblock_header *)MEMORY_ALIGN_ADDR( HEAP_ALIGN_SIZE, ( (uintptr_t)prev + prev->size ) );
			heap->size = alloc_size;
			heap->next = prev->next;
			prev->next = heap;
			break;
		}
	}
	
	/*
		̎_Ŋ蓖ĂĂȂꍇAprevƂ̃ubNwĂ̂ŁA
		q[v̏I[prev̏I[̍疖̋󂫃`FbNB
	*/
	
	if( ! heap &&  ( ( (uintptr_t)uid + ((struct heap_allocated_memblock_header *)uid)->size ) - ( (uintptr_t)prev + prev->size ) >= alloc_size ) ){
		heap = (struct heap_allocated_memblock_header *)MEMORY_ALIGN_ADDR( HEAP_ALIGN_SIZE, ( (uintptr_t)prev + prev->size ) );
		heap->size = alloc_size;
		heap->next = prev->next;
		prev->next = heap;
	}
	
	return heap ? (void *)( (uintptr_t)heap + sizeof( struct heap_allocated_memblock_header ) ) : NULL;
}
