/*
	makepath.c
*/


#include "../makepath.h"
#include <ctype.h>
#include "util/strutil.h"
#include "memory/memory.h"

/*
	pX "drive:" ̒擾B
	݂Ȃꍇ0B
*/
static int makepath_get_drive_offset( const char *path )
{
	const char *drive_end = strchr( path, ':' );
	
	if( drive_end ){
		return drive_end - path;
	} else{
		return 0;
	}
}

/*
	΃pX𐳋KB
	/..//./Adir/../dir2/ƌ璷\̂ĂB
	̐A̒邱Ƃ͂Ȃ̂ŁAobt@TCYlȂB
*/
static void makepath_normalize_abspath( char *path )
{
	int i, j;
	
	/* hCu΂ */
	path += makepath_get_drive_offset( path );
	
	/* "//","///"Ȃǂ̖ʂȃXbV̘Ar */
	for( i = 0, j = 0; path[i + 1]; i++ ){
		if( path[i] == '/' && path[i + 1] == '/' ) continue;
		if( j < i ) path[j] = path[i];
		j++;
	}
	path[j++] = path[i];
	path[j]   = '\0';
	
	/* "." ƂJgfBNgwr */
	for( i = 0, j = 0; path[i + 1]; i++ ){
		if(
			path[i] == '/' &&
			path[i + 1] == '.' &&
			( path[i + 2] == '/' || path[i + 2] == '\0' )
		){
			i += 1;
			continue;
		}
		if( j < i ) path[j] = path[i];
		j++;
	}
	path[j++] = path[i];
	path[j]   = '\0';
	
	/* efBNgw".." */
	for( i = 0, j = 0; path[i]; i++ ){
		if(
			path[i] == '/' &&
			path[i + 1] == '.' &&
			path[i + 2] == '.' &&
			( path[i + 3] == '/' || path[i + 3] == '\0' )
		){
			i += 2;
			if( j ) for( j--; j && path[j] != '/'; j-- );
			continue;
		}
		if( j < i ) path[j] = path[i];
		j++;
	}
	path[j] = '\0';
	
	if( path[j - 1] == '/' ) path[j - 1] = '\0';
}

bool makepath( const char* basepath, char *path, size_t len )
{
	unsigned short drive_offset;
	
	if( ! path || ! len ) return false;
	
	drive_offset = makepath_get_drive_offset( path );
	if( ! drive_offset ){
		drive_offset = makepath_get_drive_offset( basepath );
		
		/* basepathhCu܂܂Ȃꍇ́AtpXł͂Ȃ̂ŃG[ */
		if( ! drive_offset ) return false;
		
		if( path[0] == '/' ){
			/* pXXbVn܂Ă΁AbasepathƓhCũ[g̃pXƌȂ */
			strutilNInsert( path, basepath, drive_offset, len );
		} else{
			/* łȂbasepathRs[ */
			strutilInsert( path, "/", len );
			strutilInsert( path, basepath, len );
		}
	} else{
		/* hCu܂ނAhCu؂RŏIĂꍇ̓XbVǉ */
		if( drive_offset == strlen( path ) ) strutilCat( path, "/", len );
	}
	
	makepath_normalize_abspath( path );
	
	return true;
}
